testsite/urls.py
# Copyright (c) 2022, DjaoDjin inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import debug_toolbar
from django.conf import settings
from django.conf.urls.static import static
from django.core.exceptions import ImproperlyConfigured
from django.contrib import admin
from django.contrib.auth.decorators import login_required
from django.views.generic import TemplateView
from rules.urldecorators import include, re_path
from saas import settings as saas_settings
from saas.compat import reverse_lazy
from saas.decorators import (fail_agreement, fail_authenticated, fail_direct,
    fail_provider, fail_provider_only, fail_self_provider)
from saas.views import OrganizationRedirectView, UserRedirectView

from . import signals
from .views.app import AppView
from .views.auth import LoginAPIView, PersonalRegistrationView
from .views.organization import OrganizationListView, UserProfileView


admin.autodiscover()


def url_prefixed(regex, view, name=None, redirects=None):
    """
    Returns a urlpattern for public pages.
    """
    return re_path(r'^' + regex, view, name=name, redirects=redirects)


# admin doc and panel
try:
    urlpatterns = [
        re_path(r'^admin/doc/', include('django.contrib.admindocs.urls')),
        re_path(r'^admin/', admin.site.urls),
    ]
except ImproperlyConfigured: # Django <= 1.9
    urlpatterns = [
        re_path(r'^admin/doc/', include('django.contrib.admindocs.urls')),
        re_path(r'^admin/', include(admin.site.urls)),
    ]

urlpatterns += \
    static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT) + [
    re_path(r'^__debug__/', include(debug_toolbar.urls)),
    url_prefixed(r'register/$',
        PersonalRegistrationView.as_view(
            success_url=reverse_lazy('home')),
        name='registration_register'),
    url_prefixed(r'', include('saas.urls.views.users'),
        redirects=[fail_authenticated]),
    url_prefixed(r'users/(?P<user>[\w.@+-]+)/',
        UserProfileView.as_view(), name='users_profile',
        redirects=[fail_authenticated]),
    url_prefixed(r'users/',
        UserRedirectView.as_view(), name='accounts_profile',
        redirects=[fail_authenticated]),
    url_prefixed(r'api/auth', LoginAPIView.as_view(), name='api_login'),
    url_prefixed(r'', include('django.contrib.auth.urls')),
    url_prefixed(r'saas/$',
        OrganizationListView.as_view(), name='saas_organization_list',
        redirects=[fail_authenticated]),
    url_prefixed(r'$', TemplateView.as_view(template_name='index.html'),
        name='home'),
    url_prefixed(r'billing/cart/',
        login_required(
            OrganizationRedirectView.as_view(
                implicit_create_on_none=True,
                pattern_name='saas_organization_cart'),
            login_url=reverse_lazy('registration_register')),
        name='saas_cart'),
    # saas urls with provider key to implement marketplace.
    url_prefixed(r'api/', include('saas.backends.urls.api')),
    url_prefixed(r'api/', include('saas.urls.api.cart')),
    url_prefixed(r'api/', include('saas.urls.api.legal'),
        redirects=[fail_authenticated]),
    url_prefixed(r'api/', include('saas.urls.api.search'),
        redirects=[fail_authenticated]),
    url_prefixed(r'api/', include('saas.urls.api.users'),
        redirects=[fail_authenticated, fail_self_provider]),
    url_prefixed(r'api/', include('saas.urls.api.headbroker'),
        redirects=[fail_authenticated, fail_provider_only]),
    # api/charges/:charge/refund must be before api/charges/
    url_prefixed(r'api/',
        include('saas.urls.api.provider.charges'),
        redirects=[fail_authenticated, fail_provider_only]),
    url_prefixed(r'api/',
        include('saas.urls.api.provider.billing'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'api/',
        include('saas.urls.api.provider.roles'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'api/',
        include('saas.urls.api.provider.subscribers'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'api/',
        include('saas.urls.api.provider.plans'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'api/',
        include('saas.urls.api.provider.metrics'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'api/', include('saas.urls.api.subscriber'),
        redirects=[fail_authenticated, fail_provider]),
    url_prefixed(r'api/', include('saas.urls.api.tailbroker'),
        redirects=[fail_authenticated, fail_provider_only]),
    # views
    url_prefixed(r'', include('saas.urls.views.request'),
        redirects=[fail_authenticated]),
    url_prefixed(r'', include('saas.urls.views.noauth')),
    url_prefixed(r'', include('saas.urls.views.headredirects'),
        redirects=[fail_authenticated]),
    url_prefixed(r'', include('saas.urls.views.broker'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'', include('saas.urls.views.provider'),
        redirects=[fail_authenticated, fail_direct]),
    url_prefixed(r'', include('saas.urls.views.subscriber'),
        redirects=[fail_authenticated, fail_agreement, fail_provider]),
    url_prefixed(r'', include('saas.urls.views.tailredirects'),
        redirects=[fail_authenticated]),

    url_prefixed(r'', include('saas.backends.urls.views')),
    url_prefixed(r'app/(?P<%s>%s)/' % (
        saas_settings.PROFILE_URL_KWARG, saas_settings.SLUG_RE),
        AppView.as_view(template_name='app.html'), name='app',
        redirects=[fail_authenticated]),
    url_prefixed(r'app/',
        AppView.as_view(template_name='app.html'), name='product_default_start',
        redirects=[fail_authenticated]),
]

saas/forms.py
# Copyright (c) 2022, DjaoDjin inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

"""
Forms shown by the saas application
"""
from __future__ import unicode_literals

from decimal import Decimal

from django import forms
from django.template.defaultfilters import slugify
from django.utils.safestring import mark_safe
from django_countries import countries
from django_countries.fields import Country
import localflavor.us.forms as us_forms
from phonenumber_field.formfields import PhoneNumberField

from . import settings
from .compat import gettext_lazy as _
from .models import AdvanceDiscount, Plan, Subscription
from .utils import get_organization_model

#pylint: disable=no-member

class PhoneField(PhoneNumberField):

    def __init__(self, *args, **kwargs):
        region = kwargs.get('region')
        if not region:
            params = {'region': 'US'}
            params.update(kwargs)
        else:
            params = kwargs
        super(PhoneField, self).__init__(*args, **params)


class BankForm(forms.ModelForm):
    """
    Update Bank Information
    """
    form_id = 'bank-form'
    stripeToken = forms.CharField(
        required=False, widget=forms.widgets.HiddenInput())

    class Meta:
        model = get_organization_model()
        fields = tuple([])


class PostalFormMixin(object):

    def add_postal_country(self, field_name='country', required=True):
        self.fields[field_name] = forms.CharField(
            widget=forms.widgets.Select(choices=countries),
            label=_("Country"), required=required)

    def add_postal_region(self, field_name='region',
                          country=None, required=True):
        if country and country.code == "US":
            widget = us_forms.USPSSelect
        else:
            widget = forms.widgets.TextInput
        if field_name in self.fields:
            self.fields[field_name].widget = widget()
        else:
            self.fields[field_name] = forms.CharField(widget=widget,
                label=_("State/Province/County"), required=required)



class CreditCardForm(PostalFormMixin, forms.Form):
    """
    Update Card Information.
    """
    stripeToken = forms.CharField(required=False)
    razorpay_payment_id = forms.CharField(required=False)
    remember_card = forms.BooleanField(
        label=_("Remember this card"), required=False, initial=True)

    def __init__(self, *args, **kwargs):
        #call our superclasse's initializer
        super(CreditCardForm, self).__init__(*args, **kwargs)
        #define other fields dynamically:
        self.fields['card_name'] = forms.CharField(
            label=_("Card Holder"), required=False)
        self.fields['card_city'] = forms.CharField(
            label=_("City/Town"), required=False)
        self.fields['card_address_line1'] = forms.CharField(
            label=_("Street address"), required=False)
        self.add_postal_region(country=self.initial['country'], required=False)
        self.fields['card_address_zip'] = forms.CharField(
            label=_("Zip/Postal code"), required=False)
        self.add_postal_country(required=False)
        for item in self.initial:
            if item.startswith('cart-'):
                self.fields[item] = forms.CharField(required=True)

    def clean_remember_card(self):
        remember_card = self.data.get('remember_card', None)
        if remember_card is not None:
            self.cleaned_data['remember_card'] = (
                remember_card not in ("0", "off"))
        return self.cleaned_data['remember_card']


class VTChargeForm(CreditCardForm):

    amount = forms.CharField()
    descr = forms.CharField()

    def clean_amount(self):
        amount = self.cleaned_data['amount']
        try:
            self.cleaned_data['amount'] = int(Decimal(amount) * 100)
        except (TypeError, ValueError) as err:
            raise forms.ValidationError(
                _("'%(amount)s' is an invalid amount (%(err)s)") % {
                    'amount': amount, 'err': err})
        return self.cleaned_data['amount']


class CartPeriodsForm(forms.Form):

    def __init__(self, *args, **kwargs):
        super(CartPeriodsForm, self).__init__(*args, **kwargs)
        for item in self.initial:
            if item.startswith('cart-'):
                self.fields[item] = forms.CharField(required=True)


class ImportTransactionForm(forms.Form):

    subscription = forms.CharField()
    created_at = forms.DateTimeField()
    amount = forms.DecimalField()
    descr = forms.CharField(required=False)

    def clean_subscription(self):
        parts = self.cleaned_data['subscription'].split(Subscription.SEP)
        if len(parts) != 2:
            raise forms.ValidationError(
                _("Subscription should be of the form subscriber:plan."))
        return self.cleaned_data['subscription']

    def clean_amount(self):
        amount = self.cleaned_data['amount']
        try:
            self.cleaned_data['amount'] = int(Decimal(amount) * 100)
        except (TypeError, ValueError):
            raise forms.ValidationError(_("Invalid amount"))
        return self.cleaned_data['amount']



class OrganizationForm(PostalFormMixin, forms.ModelForm):

    submit_title = _('Update')
    slug = forms.SlugField(max_length=254, label=_("Display name"),
        disabled=True,
        error_messages={'invalid': _("Display name may only contain letters,"\
            " digits and -/_ characters. Spaces are not allowed.")})
    street_address = forms.CharField(label=_("Street address"), required=False)
    phone = PhoneField(label=_("Phone number"), required=False)

    class Meta:
        model = get_organization_model()
        fields = ('slug', 'full_name', 'email', 'phone', 'country',
                  'region', 'locality', 'street_address', 'postal_code')
        widgets = {'country': forms.widgets.Select(choices=countries)}

    def __init__(self, *args, **kwargs):
        super(OrganizationForm, self).__init__(*args, **kwargs)
        if kwargs.get('instance', None) is None:
            self.submit_title = _('Create')
        if 'country' in self.fields:
            # Country field is optional. We won't add a State/Province
            # in case it is omitted.
            if not ('country' in self.initial
                and self.initial['country']):
                self.initial['country'] = Country("US", None)
            country = self.initial.get('country', None)
            if self.instance and self.instance.country:
                country = self.instance.country
            if not self.fields['country'].initial:
                self.fields['country'].initial = country.code
            self.add_postal_region(country=country)
        if 'is_bulk_buyer' in self.initial:
            initial = self.initial['is_bulk_buyer']
            if self.instance:
                initial = self.instance.is_bulk_buyer
            self.fields['is_bulk_buyer'] = forms.BooleanField(required=False,
                initial=initial,
                label=mark_safe(_("Enable GroupBuy (<a href=\""\
"https://djaodjin.com/docs/#group-billing\" target=\"_blank\">what is it?</a>)"
                )))
        if 'is_provider' in self.initial:
            initial = self.initial['is_provider']
            if self.instance:
                initial = self.instance.is_provider
            self.fields['is_provider'] = forms.BooleanField(required=False,
                label=_("Enable creation of subscription plans"),
                initial=initial)
        if 'extra' in self.initial:
            initial = self.initial['extra']
            if self.instance:
                initial = self.instance.extra
            self.fields['extra'] = forms.CharField(required=False,
                widget=forms.Textarea, label=mark_safe('Notes'),
                initial=initial)


class OrganizationCreateForm(OrganizationForm):

    slug = forms.SlugField(label=_("Display name"),
        help_text=_("Unique identifier shown in the URL bar"))

    class Meta:
        model = get_organization_model()
        fields = ('slug', 'full_name', 'email')


class ManagerAndOrganizationForm(OrganizationForm):

    def __init__(self, *args, **kwargs):
        super(ManagerAndOrganizationForm, self).__init__(*args, **kwargs)
        self.fields['full_name'].label = 'Full name'
        # XXX define other fields dynamically (username, etc.):
        # Unless it is not necessary?


class PlanForm(forms.ModelForm):
    """
    Form to create or update a ``Plan``.
    """
    submit_title = _("Update")

    period_type = forms.ChoiceField(choices=[
        (slugify(choice[1]), choice[1]) for choice in Plan.INTERVAL_CHOICES])
    renewal_type = forms.ChoiceField(choices=[

saas/templates/saas/billing/balance.html
{% extends "saas/billing/cart.html" %}

{% block order_title %}Balance due{% endblock %}

{% block order_head %}{% endblock %}

{% block no_invoicables %}<p>You have no balance due.</p>{% endblock %}

{% block order_footer %}
<section id="charge">
{% if not last_charge %}
A charge of {{lines_price|humanize_money}} will be created
on your card. Thank you.
{% else %}
{% with last_charge as charge %}
{% if charge.is_failed or charge.is_disputed %}
<p>
On {{charge.created_at}} we attempted to charge your card
</p>
<div>
    <dl>
        <dt>card</dt>
        <dd>{{charge.last4}}</dd>
    </dl>
    <dl>
        <dt>expires</dt>
        <dd>{{charge.exp_date}}</dd>
    </dl>
</div>
<p>
The charge
{% if charge.is_failed %}failed
{% else %}
{% if charge.is_disputed %}was disputed
{% endif %}
{% endif %}
(ref: {{charge.processor_key}}).
</p>
<p>
Please enter a valid credit card. A new charge of
{{lines_price|humanize_money}} will be created. Thank you.
</p>
{% endif %}
{% endwith %}
{% endif %}
</section>
{% endblock %}

saas/templates/saas/billing/bank.html
{% extends "saas/base.html" %}

{% block saas_title %}
{{organization.printable_name}} Payment Processor
{% endblock %}

{% block saas_content %}
<div>
  {% if bank_name and bank_name != 'N/A' %}
  <div>
    <div>
      <h3>Connected Processor</h3>
      <div>
        <p>
You will be able to create charges and payout funds with this processor.
        </p>
        <div>
          <dl>
            <dt>Institution</dt>
            <dd>
              <span>{{bank_name}}</span>
            </dd>
          </dl>
          <dl>
            <dt>Account Number</dt>
            <dd>
              <span>{{last4}}</span>
            </dd>
          </dl>
        </div>
        {% if urls.provider.deauthorize_processor %}
        <form method="post" action="{{urls.provider.deauthorize_processor}}">
          <input type="hidden" name="csrfmiddlewaretoken" value="{{csrf_token}}">
          <input type="hidden" name="stripeToken" value="OOPS" />
          <button id="de-authorize-action-btn" type="submit">De-authorize</button>
        </form>
        {% endif %}
      </div>
    </div>
  </div>
  {% else %}
  {% if urls.authorize_processor %}
      <div>
        <div>
          <h3>Stripe Account</h3>
          <div>
            <h5>Connect your Stripe account</h5>
            <p>
You will be able to create charges on credit cards.
            </p>
            <p>
If you already have a Stripe account, we recommend that you first login into
your Stripe account before clicking the button below.
            </p>
            <p>
              <a href="https://stripe.com/login/" target="_blank">Login to Stripe &raquo;</a>
            </p>
            <a href="{{urls.authorize_processor}}">Connect</a>
          </div>
        </div>
      </div>
  {% endif %}
  {% if not urls.authorize_processor %}
  {# dealing with a misconfigured platform #}
  <div>
    <div>
      <h3>Configure Settings</h3>
      <div>
        <p>
The configuration variables STRIPE_CLIENT_ID, STRIPE_PUB_KEY
and STRIPE_PRIV_KEY are invalid. You will need to retrieve
the StripeConnect ClientID, and the pair of publishable/private
API keys for your Stripe account on
<a href="https://stripe.com/" target="_blank">stripe.com</a>.
        </p>
        <p>
Once you have those keys, write them in the <em>credentials</em>
configuration file and restart the server.
        </p>
      </div>
    </div>
  </div>
  {% endif %}
  {% endif %}
</div>
{% endblock %}

saas/templates/saas/billing/card.html
{% extends "saas/base_dashboard.html" %}

{% block saas_content %}
<card-update inline-template id="update-card-container"
    data-processor-pub-key="{{STRIPE_PUB_KEY}}"
    {% if STRIPE_INTENT_SECRET %}
    data-stripe-intent-secret="{{STRIPE_INTENT_SECRET}}"
    {% endif %}
    {% if STRIPE_ACCOUNT %}
    data-stripe-account="{{STRIPE_ACCOUNT}}"
    {% endif %}
  >
  <div>
    <h1>Update Card for {{organization}}</h1>
    <form id="update-card" method="post"
        action=".{% if next %}/?next={{next}}{% endif %}"
        v-on:submit.prevent="save">
        <input type="hidden" name="csrfmiddlewaretoken" value="{{csrf_token}}">
        {% include "saas/_card_use.html" %}
        <div id="delete-action-open">
            <div id="delete-action">
                <button type="button" id="delete-card-btn"
                        @click.prevent="remove"
                        v-if="haveCardData">Remove</button>
            </div>
        </div>
    </form>
  </div>
</card-update>
{% endblock %}

saas/templates/saas/billing/cart-periods.html
{% extends "saas/billing/cart.html" %}

{% block order_title %}Place order ...{% endblock %}

{% block order_card %}
<div>
    <button type="submit" class="payment-submit">Next &raquo;</button>
</div>
{% endblock %}

saas/templates/saas/billing/cart.html
{% extends "saas/base.html" %}

{% block content %}
<h1>{% block order_title %}Place Order{% endblock %}</h1>
<div id="app">
  {% block order_head %}
  <div>
    <form method="post" id="redeem-form">
      <input type="hidden" name="csrfmiddlewaretoken" value="{{csrf_token}}">
      <div>
        <label>
If you have a coupon code, it is time to redeem it now!
        </label>
        <div id="redeem-code">
          <div class="collapsible">
            <input name="code" type="text" placeholder="Coupon code">
            <button type="submit" class="submit-code">Redeem</button>
          </div>
        </div>
      </div>
    </form>
  </div>
  {% endblock %}
  <div>
    <form id="payment-form" method="post" action=".{% if next %}/?next={{ next }}{% endif %}">
        <input type="hidden" name="csrfmiddlewaretoken" value="{{csrf_token}}">
        {% if invoicables %}
        {% include "saas/_invoiceables.html" %}
        {% else %}
        {% block no_invoicables %}
        Your subscription cart is empty.
        {% endblock %}
        {% endif %}
        {% block order_footer %}
        {% endblock order_footer %}
        {% block order_card %}
        {% if RAZORPAY_PUB_KEY %}
        {% include "saas/_razorpay_checkout.html" %}
        <div>
          <button type="submit" class="payment-submit">{% if submit_title %}{{submit_title}}{% else %}Submit{% endif %}</button>
        </div>
        {% elif STRIPE_PUB_KEY %}
        {% include "saas/_card_use.html" %}
        {% else %}
        <p>
Either variables RAZORPAY_PUB_KEY or STRIPE_PUB_KEY must be defined.
        </p>
        {% endif %}
        {% endblock %}
    </form>
  </div>
</div>
{% endblock %}

{% block saas_bodyscripts %}
<script type="text/javascript" charset="utf-8" src="/static/js/djaodjin-stripe.js"></script>
<script type="text/javascript">
jQuery(document).ready(function($) {
    var cardForm = $("#payment-form");
{% if urls and urls.api_cart %}
    if( cardForm.length > 0 ) {
        cardForm.find("#invoicables").invoice(
            {currency_unit: "{% if lines_price %}{{ lines_price.unit }}{% endif %}",
             saas_api_cart: "{{ urls.api_cart }}" });
    }
{% endif %}
{% if STRIPE_PUB_KEY %}
    cardForm.card({
        stripePubKey: "{{ STRIPE_PUB_KEY }}",
        stripeIntentSecret: {% if STRIPE_INTENT_SECRET %}"{{ STRIPE_INTENT_SECRET }}"{% else %}null{% endif %},
        stripeAccount: {% if STRIPE_ACCOUNT %}"{{ STRIPE_ACCOUNT }}"{% else %}null{% endif %},
        saas_api_card: "{{ urls.organization.api_card }}"
    });
{% endif %}
});
</script>
{% endblock %}

saas/templates/saas/billing/charges.html
{% extends "saas/base_dashboard.html" %}

{% block saas_content %}
<charge-list inline-template id="charge-list-container" ng-app="saasApp">
  <div>
  {% include "saas/_charges.html" %}
  </div>
</charge-list>
{% endblock %}

saas/templates/saas/billing/import.html
{% extends "saas/base_dashboard.html" %}

{% block saas_title %}Add offline transaction{% endblock %}

{% block saas_content %}
<import-transaction inline-template id="import-transaction-container" ng-app="saasApp" ng-cloak>
  <div ng-controller="importTransactionsCtrl">
    <form @submit.prevent="addPayment">
      <input type="hidden" name="csrfmiddlewaretoken" value="{{csrf_token}}">
      <fieldset>
        <div class="{% if form.subscription.errors %} has-error{% endif %}">
          <label for="subscription">
            Subscription
          </label>
          <div>
            <input
               id="subscription"
               class="form-control"
               type="text"
               placeholder="Subscriber name or email"
               name="subscription"
               autocomplete="off"
               ng-model="subscription"
               v-model="itemSelected" />
          </div>
        </div>
        <div>
          <label for="amount">
            Amount
          </label>
          <div>
            <input name="amount" type="number" min="0" step="any" placeholder="amount" v-model="amount">
          </div>
        </div>
        <div>
          <label for="descr">
            Description
          </label>
          <div>
            <input name="descr" type="text" placeholder="description" v-model="description">
          </div>
        </div>
      </fieldset>
      <div>
        <button type="submit">Add Off-line Payment</button>
      </div>
    </form>
  </div>
</import-transaction>
{% endblock %}

saas/templates/saas/billing/transactions.html
{% extends "saas/base_dashboard.html" %}

{% block saas_content %}
<transfers-statement inline-template>
<div>
  {% include "saas/_filter.html" %}
  <table>
    <thead>
      <tr>
        <th>Date</th>
        <th>Amount</th>
        <th>Origin Profile</th>
        <th>Origin Account</th>
        <th>Destination Profile</th>
        <th>Destination Account</th>
        <th>Description</th>
      </tr>
      </thead>
    <tbody id="has-transactions"
           v-show="itemsLoaded && items.results.length > 0">
      <tr v-for="entry in items.results">
        <td>[[entry.created_at]]</td>
        <td>[[entry.amount]]</td>
        <td>[[entry.orig_profile.printable_name]]</td>
        <td>[[entry.orig_account]]</td>
        <td>[[entry.dest_profile.printable_name]]</td>
        <td>[[entry.dest_account]]</td>
        <td v-html="entry.description"></td>
      </tr>
    </tbody>
  </table>
</div>
</transfers-statement>
{% endblock %}

saas/templates/saas/billing/withdraw.html
{% extends "saas/base.html" %}

{% block saas_content %}
<h1>Withdraw funds to your bank account</h1>

<form method="post" id="bank-form"
      action=".{% if next %}/?next={{ next }}{% endif %}">
    <input type="hidden" name="csrfmiddlewaretoken" value="{{csrf_token}}">
    <input name="stripeToken" type="hidden">
    <fieldset>
        <legend>Amount to transfer</legend>
        <div>
         <label for="id_amount">Amount (in $):</label>
         {{form.amount}}
        </div>
      </fieldset>
      <button type="submit">{% if form.submit_title %}{{form.submit_title}}{% else %}Submit{% endif %}</button>
</form>
{% endblock %}